package com.ematou.wxbase.common.web;

import lombok.Data;

import java.io.Serializable;

/**
 * @author lhm
 * @version 1.0
 * 2021-04-30 14:25
 */
@Data
public class R<T> implements Serializable {

    private int code;

    private String message;

    private T data;

    public R() {
    }

    public R(int code, String message, T data) {
        this.code = code;
        this.message = message;
        this.data = data;
    }

    public static <T> R<T> success(T data) {
        return restResult(data, ResponseCodeConstant.code_200, "成功");
    }

    public static <T> R<T> error(String message) {
        return restResult(null, ResponseCodeConstant.code_500, message);
    }

    public static <T> R<T> error(int code, String message) {
        return restResult(null, code, message);
    }

    private static <T> R<T> restResult(T data, int code, String msg)
    {
        R<T> apiResult = new R<>();
        apiResult.setCode(code);
        apiResult.setData(data);
        apiResult.setMessage(msg);
        return apiResult;
    }

}
